Qt: Accelerators are not translated correctly
Description

translate_str() in libaudqt/util.cc
assumes the accelerator is always the prefix of a single word.
This is not always true.

Some accelerators are conventions or are placed somewhere else to prevent conflicts.

My suggestion is to translate the first underscore in all cases.
At least for the German translation this has no side effects.

History

#1 - October 14, 2014 17:00 - John Lindgren

How about using str_replace_char()?

#2 - October 14, 2014 17:20 - Thomas Lange

| think that's fine.
All translated strings should contain only one accelerators already.
And | doubt that translators use underscores for other purposes than accelerators.

#3 - October 17, 2014 21:47 - Ariadne Conill

My concern with str_replace_char() is multibyte safety, i.e. CJK translations. If you want to change the behaviour to translate the first underscore
always, that is fine.

#4 - October 17, 2014 23:34 - Thomas Lange
- File 01_translate_str.patch added
- File 02_translate_str.patch added

John, what do you think about this?
Can str_replace_char() be used for these translations?

If not, we can use one of the attached patches.

#5 - October 18, 2014 05:59 - John Lindgren

William Pitcock wrote:

My concern with str_replace_char() is multibyte safety, i.e. CJK translations. If you want to change the behaviour to translate the first underscore
always, that is fine.
All of our translations are UTF-8, so multibyte characters should (thankfully) not be an issue.

#6 - October 18, 2014 15:34 - Thomas Lange
- File 03_translate_str.patch added

OK, please take a look on the attached patch.
Two questions:

Is str_copy() the right function to use here or should it be str_to_utf8()?
What is the intention of "src"? Using "str" instead also works correctly.

#7 - October 18, 2014 16:33 - John Lindgren

The translations are already UTF-8, so str_to_utf8() is unnecessary. You can use str directly if you want, there's no difference either way.

#8 - October 18, 2014 17:34 - Thomas Lange
- File deleted (01_translate_str.patch)

#9 - October 18, 2014 17:34 - Thomas Lange
- File deleted (02_translate_str.patch)

#10 - October 18, 2014 17:34 - Thomas Lange
- File deleted (03_translate_str.patch)

#11 - October 18, 2014 17:35 - Thomas Lange
- File translate_str.patch added

Updated patch attached.
#12 - October 26, 2014 17:17 - John Lindgren
- Status changed from New to Closed

- % Done changed from 0 to 100

| committed a patch that uses QString::replace(). QString is what we eventually need anyway, so there's no reason to use the intermediate StringBuf.

Files
Example.png 3.55 KB October 14, 2014 Thomas Lange
translate_str.patch 1.34 KB October 18, 2014 Thomas Lange
